package Main " file: Main.mo "
  
import Absyn;
import Parse;
import Eval;

protected function printvalue
  input Eval.Value in_value;
algorithm 
  _ :=
  matchcontinue (in_value)
    local
      String x_1;
      Integer x;
    case (Eval.INTval(x))
      equation 
        x_1 = int_string(x);
        print(x_1); then ();
    case (Eval.REALval(x))
      local Real x;
      equation 
        x_1 = real_string(x);
        print(x_1); then ();
  end matchcontinue;
end printvalue;

protected function eval_loop
  input Eval.Env in_env;
algorithm 
  _ :=
  matchcontinue (in_env)
    local
      Absyn.Exp ast;
      list<tuple<String,Eval.Value>> env2,env;
      Eval.Value value;
    case (env)
      equation 
        print("\n> ");
        ast = Parse.parse();
        (env2,value) = Eval.eval(env, ast);
        printvalue(value);
        eval_loop(env2); then ();
    case (env) "** INCOMPLETE!! "
      equation 
        failure(ast = Parse.parse());
        //print("Syntax error in input line\n"); 
        then ();
  end matchcontinue;
end eval_loop;

public function main "Main"
  input StringList in_stringlist;
  output Boolean dummy;
protected 
  type StringList = list<String>;
algorithm 
  dummy:=
  matchcontinue (in_stringlist)
    case _
      equation 
        eval_loop(Eval.init_env); then true;
  end matchcontinue;
end main;
end Main;

