# VARIABLES

GOROOT=..

LDLIBS = -lrml -lfl -lm
CALCOBJS= Main.o lexer.o gram.o yacclib.o Absyn.o Eval.o Parse.o
CLEAN=calc $(CALCOBJS) lexer.c Main.c Main.h Absyn.c Absyn.h Eval.c Eval.h gram.c gram.h lexer.c *~ calc.exe
#CPPFLAGS=-DDEBUG -Dg -DEBUG -g -DLEXDEBUG=1 -DYYDEBUG=1

# EVERYTHING
all:	calc


# MAIN PROGRAM
calc: $(CALCOBJS)
	$(LINK.rml) $(CALCOBJS) $(LDLIBS) -o calc


# LEXER

lexer.o:  lexer.c gram.h Absyn.h
lexer.c:  lexer.l
	flex -t lexer.l >lexer.c

# PARSER

gram.o:  gram.c gram.h
gram.c gram.h:  gram.y
	bison -t -d gram.y
	mv gram.tab.c gram.c
	mv gram.tab.h gram.h


# ABSTRACT SYNTAX and EVALUATION

Absyn.o:  Absyn.c
Absyn.c Absyn.h:	Absyn.mo
	$(COMPILE.rml) -c Absyn.mo

Eval.o:  Eval.c
Eval.c Eval.h:	Eval.mo
	$(COMPILE.rml) Eval.mo

Parse.o:  Parse.c
Parse.c:  Parse.mo
	$(COMPILE.rml) +C Parse.c

Main.o:  Main.c
Main.c Main.h:	Main.mo Parse.o
	$(COMPILE.rml) Main.mo

	
# running the program
run: calc
	./calc < program.txt

# AUX

include $(GOROOT)/etc/client.mk
